From 3e631657b8a6ee308eaeef97ffc85640e646f7f0 Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Sun, 8 Sep 2019 15:00:12 -0400
Subject: [PATCH 20/31] significant refactoring in SquadService operations;
 properly force the player to leave any participating squad when WSA stops

---
 .../scala/services/teamwork/SquadAction.scala |    2 +-
 .../services/teamwork/SquadService.scala      | 1604 ++++++++++++-----
 .../teamwork/SquadServiceMessage.scala        |    3 +-
 .../game/SquadMembershipResponseTest.scala    |   70 +-
 .../src/main/scala/WorldSessionActor.scala    |    9 +-
 5 files changed, 1189 insertions(+), 499 deletions(-)

diff --git a/common/src/main/scala/services/teamwork/SquadAction.scala b/common/src/main/scala/services/teamwork/SquadAction.scala
index d5da028e..5b3ed90e 100644
--- a/common/src/main/scala/services/teamwork/SquadAction.scala
+++ b/common/src/main/scala/services/teamwork/SquadAction.scala
@@ -8,7 +8,7 @@ import net.psforever.types.{SquadRequestType, Vector3}
 object SquadAction {
   trait Action
 
-  final case class Definition(zone : Zone, guid : PlanetSideGUID, line : Int, action : SquadAction) extends Action
+  final case class Definition(guid : PlanetSideGUID, line : Int, action : SquadAction) extends Action
   final case class Membership(request_type : SquadRequestType.Value, unk2 : Long, unk3 : Option[Long], player_name : String, unk5 : Option[Option[String]]) extends Action
   final case class Waypoint(event_type : WaypointEventAction.Value, waypoint_type : Int, unk : Option[Long], waypoint_info : Option[WaypointInfo]) extends Action
   final case class Update(char_id : Long, health : Int, max_health : Int, armor : Int, max_armor : Int, pos : Vector3, zone_number : Int) extends Action
diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 5bbd895c..2c22886c 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -1,11 +1,12 @@
 // Copyright (c) 2019 PSForever
 package services.teamwork
 
-import akka.actor.{Actor, ActorRef, Props}
+import akka.actor.{Actor, ActorContext, ActorRef, Props}
 import net.psforever.objects.Player
 import net.psforever.objects.definition.converter.StatConverter
 import net.psforever.objects.loadouts.SquadLoadout
 import net.psforever.objects.teamwork.{Member, Squad}
+import net.psforever.objects.zones.Zone
 import net.psforever.packet.game._
 import net.psforever.types._
 import services.{GenericEventBus, Service}
@@ -19,73 +20,35 @@ import scala.collection.mutable.ListBuffer
 class SquadService extends Actor {
   import SquadService._
 
-  private var memberToSquad : mutable.LongMap[Squad] = mutable.LongMap[Squad]()
-  private var idToSquad : TrieMap[PlanetSideGUID, Squad] = new TrieMap[PlanetSideGUID, Squad]()
-  private var idToSwitchboard : TrieMap[PlanetSideGUID, ActorRef] = new TrieMap[PlanetSideGUID, ActorRef]()
+  /**
+    * The current unique squad identifier, to be wrapped in a `PlanetSideGUID` object later.
+    * The count always starts at 1, even when reset.
+    * A squad of `PlanetSideGUID(0)` indicates both a nonexistent squad and the default no-squad for clients.
+    */
   private var sid : Int = 1
+
+  private var memberToSquad : mutable.LongMap[Squad] = mutable.LongMap[Squad]()
+  private val invites : mutable.LongMap[Invitation] = mutable.LongMap[Invitation]()
+  private val queuedInvites : mutable.LongMap[List[Invitation]] = mutable.LongMap[List[Invitation]]()
+  /**
+    * A placeholder for an absent active invite that has not (yet) been accepted or rejected, equal to the then-current active invite.
+    * Created when removing an active invite.
+    * Checked when trying to add a new invite (if found, the invite is queued).
+    * Cleared when the next queued invite becomes active.
+    */
+  private val previousInvites : mutable.LongMap[Invitation] = mutable.LongMap[Invitation]()
+
+  private var squadFeatures : TrieMap[PlanetSideGUID, SquadService.SquadFeatures] = new TrieMap[PlanetSideGUID, SquadService.SquadFeatures]()
   private val publishedLists : TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]] = TrieMap[PlanetSideEmpire.Value, ListBuffer[SquadInfo]](
     PlanetSideEmpire.TR -> ListBuffer.empty,
     PlanetSideEmpire.NC -> ListBuffer.empty,
     PlanetSideEmpire.VS -> ListBuffer.empty
   )
-  private val invites : mutable.LongMap[Invitation] = mutable.LongMap[Invitation]()
-  /**
-    * `initialAssociation` per squad is similar to "Does this squad want to recruit members?"
-    * The squad does not have to be listed.
-    * Dispatches an `AssociateWithSquad` `SDAM` to the squad leader and ???
-    * and then a `SDDUM` that includes at least the squad owner name and char id
-    * when a squad entry is removed from the list.
-    * Dispatched only once when a squad is first listed
-    * or when the squad leader searches for recruits by proximity or for certain roles or by invite
-    * or when a spontaneous squad forms,
-    * whichever happens first.
-    * Additionally, the packets are also sent when the check is made when the continent is changed (or set).
-    */
-  private val initialAssociation : ListBuffer[PlanetSideGUID] = new ListBuffer[PlanetSideGUID]()
-  private val queuedInvites : mutable.LongMap[List[Invitation]] = mutable.LongMap[List[Invitation]]()
-  private val waypoints : TrieMap[PlanetSideGUID, Array[WaypointData]] =
-    new TrieMap[PlanetSideGUID, Array[WaypointData]]()
-  private val viewDetails : mutable.LongMap[PlanetSideGUID] = mutable.LongMap[PlanetSideGUID]()
 
   private [this] val log = org.log4s.getLogger
 
   override def preStart : Unit = {
     log.info("Starting...")
-
-//    val testSquad = new Squad(PlanetSideGUID(3), PlanetSideEmpire.VS)
-//    testSquad.Task = "\\#66CCFF Sentinels of Auraxis\\#FFFFFF ... \\#40FF40 Squad Up!!"
-//    testSquad.ZoneId = 5
-//    testSquad.Membership(0).Name = "Wizkid45"
-//    testSquad.Membership(0).Role = "Fearless Leader"
-//    testSquad.Membership(0).CharId = 30910985L
-//    testSquad.Membership(0).ZoneId = 5
-//    testSquad.Membership(0).Health = 64
-//    testSquad.Membership(0).Armor = 34
-//    testSquad.Membership(0).Position = Vector3(5526.5234f, 3818.7344f, 54.59375f)
-//    testSquad.Membership(1).Name = "xoBLADEox"
-//    testSquad.Membership(1).Role = "Right Hand"
-//    testSquad.Membership(1).CharId = 42781919L
-//    testSquad.Membership(1).ZoneId = 5
-//    testSquad.Membership(1).Health = 54
-//    testSquad.Membership(1).Armor = 44
-//    testSquad.Membership(1).Position = Vector3(4673.5312f, 2604.8047f, 40.015625f)
-//    testSquad.Membership(3).Name = "cabal0428"
-//    testSquad.Membership(3).Role = "Left Hand"
-//    testSquad.Membership(3).CharId = 353380L
-//    testSquad.Membership(3).ZoneId = 5
-//    testSquad.Membership(3).Health = 44
-//    testSquad.Membership(3).Armor = 54
-//    testSquad.Membership(3).Position = Vector3(4727.492f, 2613.5312f, 51.390625f)
-//    testSquad.Membership(4).Name = "xSkiku"
-//    testSquad.Membership(4).Role = "Right Foot's Middle Toe's Nail"
-//    testSquad.Membership(4).CharId = 41588340L
-//    testSquad.Membership(4).ZoneId = 5
-//    testSquad.Membership(4).Health = 34
-//    testSquad.Membership(4).Armor = 64
-//    testSquad.Membership(4).Position = Vector3(3675.0f, 4789.8047f, 63.21875f)
-//    idToSquad(PlanetSideGUID(3)) = testSquad
-//    testSquad.Listed = true
-//    UpdateSquadList(testSquad, None)
   }
 
   def GetNextSquadId() : PlanetSideGUID = {
@@ -101,7 +64,7 @@ class SquadService extends Actor {
   }
 
   def TryResetSquadId() : Boolean = {
-    if(idToSquad.isEmpty) {
+    if(squadFeatures.isEmpty) {
       sid = 1
       true
     }
@@ -110,6 +73,13 @@ class SquadService extends Actor {
     }
   }
 
+  def GetSquad(id : PlanetSideGUID) : Option[Squad] = {
+    squadFeatures.get(id) match {
+      case Some(features) => Some(features.Squad)
+      case None => None
+    }
+  }
+
   def GetParticipatingSquad(player : Player) : Option[Squad] = {
     GetParticipatingSquad(player.CharId)
   }
@@ -159,7 +129,6 @@ class SquadService extends Actor {
   }
 
   def CreateSquad(player : Player) : Squad = {
-    val charId = player.CharId
     val faction = player.Faction
     val name = player.Name
     val squad = new Squad(GetNextSquadId(), faction)
@@ -170,18 +139,13 @@ class SquadService extends Actor {
     leadPosition.Armor = player.Armor
     leadPosition.Position = player.Position
     leadPosition.ZoneId = 1
-    log.info(s"$name-$faction has started a new squad")
+    log.info(s"$name-$faction has created a new squad")
     squad
   }
 
   def StartSquad(squad : Squad) : Squad = {
-    val charId = squad.Leader.CharId
-    val id = squad.GUID
-    val switchboard = context.actorOf(Props[SquadSwitchboard], s"squad${id.guid}")
-    memberToSquad += charId -> squad
-    idToSquad += id -> squad
-    idToSwitchboard += id -> switchboard
-    initialAssociation += squad.GUID
+    squadFeatures += squad.GUID -> new SquadService.SquadFeatures(squad).Start
+    memberToSquad += squad.Leader.CharId -> squad
     squad
   }
 
